use gufo_jpeg::Jpeg;

fn main() {
    let path = std::env::args()
        .nth(1)
        .expect("First agument must be a file path.");
    let out_path = std::env::args()
        .nth(2)
        .expect("Second agument must be a file path.");
    let data: Vec<u8> = std::fs::read(&path).unwrap();
    let mut jpeg = Jpeg::new(data).unwrap();

    for segment in jpeg.segments() {
        let data_init = segment
            .data()
            .iter()
            .take(50)
            .take_while(|x| **x != b'\0')
            .filter(|x| x.is_ascii_graphic())
            .cloned()
            .collect::<Vec<_>>();
        let s = String::from_utf8_lossy(&data_init);

        println!("{:x?}: {s}", segment.marker());
    }

    //let original = image::ImageReader::open(path).unwrap();
    let original_image = original.decode().unwrap();

    let mut new = Vec::new();
    let x = jpeg.encoder(&mut new).unwrap();
    x.encode(
        &original_image.as_bytes(),
        original_image.width() as u16,
        original_image.height() as u16,
        jpeg_encoder::ColorType::Rgb,
    )
    .unwrap();

    //std::fs::write(out_path, &new).unwrap();

    let new_jpeg = Jpeg::new(new).unwrap();
    jpeg.replace_image_data(&new_jpeg).unwrap();
    std::fs::write(out_path, jpeg.into_inner()).unwrap();
}
